osgSim::BlinkSequence Class Reference

`#include <BlinkSequence>`

Inheritance diagram for osgSim::BlinkSequence:

## Public Member Functions

| BlinkSequence ()
| BlinkSequence (const BlinkSequence &bs, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgSim, BlinkSequence)
void | addPulse (double length, const osg::Vec4 &color)
int | getNumPulses () const
void | getPulse (unsigned int i, double &length, osg::Vec4 &color) const
void | setPulse (unsigned int i, double length, const osg::Vec4 &color)
double | getPulsePeriod () const
void | setSequenceGroup (SequenceGroup *sg)
SequenceGroup * | getSequenceGroup ()
const SequenceGroup * | getSequenceGroup () const
void | setPhaseShift (double ps)
double | getPhaseShift () const
double | localTime (double time) const
osg::Vec4 | color (double time, double length) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::pair< double, osg::Vec4 > | IntervalColor
typedef std::vector< IntervalColor > | PulseData

## Protected Attributes

double | _pulsePeriod
double | _phaseShift
PulseData | _pulseData
osg::ref_ptr< SequenceGroup > | _sequenceGroup
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Member Typedef Documentation

## IntervalColor

typedef std::pair<double,osg::Vec4> osgSim::BlinkSequence::IntervalColor

protected

## PulseData

typedef std::vector<IntervalColor> osgSim::BlinkSequence::PulseData

protected

## Constructor & Destructor Documentation

## BlinkSequence() [1/2]

osgSim::BlinkSequence::BlinkSequence | ( |  | ) |

Referenced by BlinkSequence(), and META_Object().

## BlinkSequence() [2/2]

osgSim::BlinkSequence::BlinkSequence | ( | const BlinkSequence & | bs,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References BlinkSequence(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## addPulse()

void osgSim::BlinkSequence::addPulse | ( | double | length,
|  | const osg::Vec4 & | color )

inline

add a pulse of specified color and duration to the BlinkSequence.

References _pulseData, _pulsePeriod, and color().

Referenced by META_Object().

## color()

osg::Vec4 osgSim::BlinkSequence::color | ( | double | time,
|  | double | length ) const

inline

compute the color for the time interval sepecifed. Averages the colors if the length is greater than the current pulse.

References _pulseData, color(), and localTime().

Referenced by addPulse(), color(), getPulse(), META_Object(), and setPulse().

## getNumPulses()

int osgSim::BlinkSequence::getNumPulses | ( |  | ) | const

inline

return the number of pulses.

References _pulseData.

## getPhaseShift()

double osgSim::BlinkSequence::getPhaseShift | ( |  | ) | const

inline

get the pahse shift.

References _phaseShift.

## getPulse()

void osgSim::BlinkSequence::getPulse | ( | unsigned int | i,
|  | double & | length,
|  | osg::Vec4 & | color ) const

inline

return the pulse data at position i.

References _pulseData, and color().

## getPulsePeriod()

double osgSim::BlinkSequence::getPulsePeriod | ( |  | ) | const

inline

get the total pulse period of the blink sequence, which is equal to the sum of all the pulse periods.

References _pulsePeriod.

## getSequenceGroup() [1/2]

SequenceGroup * osgSim::BlinkSequence::getSequenceGroup | ( |  | ) |

inline

get the non const sequence group.

References _sequenceGroup.

## getSequenceGroup() [2/2]

const SequenceGroup * osgSim::BlinkSequence::getSequenceGroup | ( |  | ) | const

inline

get the const sequence group.

References _sequenceGroup.

## localTime()

double osgSim::BlinkSequence::localTime | ( | double | time | ) | const

inline

compute the local time clamped to this BlinkSequences period, and accounting for the phase shift and sequence group.

References _phaseShift, _pulsePeriod, and _sequenceGroup.

Referenced by color().

## META_Object()

osgSim::BlinkSequence::META_Object | ( | osgSim | ,
|  | BlinkSequence | )

References addPulse(), BlinkSequence(), and color().

## setPhaseShift()

void osgSim::BlinkSequence::setPhaseShift | ( | double | ps | ) |

inline

set the phase shift of the blink sequence, this would be used to shift a sequence within a sequence group.

References _phaseShift.

## setPulse()

void osgSim::BlinkSequence::setPulse | ( | unsigned int | i,
|  | double | length,
|  | const osg::Vec4 & | color )

inline

set pulse of specified color and duration to the BlinkSequence.

References _pulseData, and color().

## setSequenceGroup()

void osgSim::BlinkSequence::setSequenceGroup | ( | SequenceGroup * | sg | ) |

inline

set the sequence group which can be used to synchronize related blink sequences.

References _sequenceGroup.

## Member Data Documentation

## _phaseShift

double osgSim::BlinkSequence::_phaseShift

protected

Referenced by getPhaseShift(), localTime(), and setPhaseShift().

## _pulseData

PulseData osgSim::BlinkSequence::_pulseData

protected

Referenced by addPulse(), color(), getNumPulses(), getPulse(), and setPulse().

## _pulsePeriod

double osgSim::BlinkSequence::_pulsePeriod

protected

Referenced by addPulse(), getPulsePeriod(), and localTime().

## _sequenceGroup

osg::ref_ptr<SequenceGroup> osgSim::BlinkSequence::_sequenceGroup

protected

Referenced by getSequenceGroup(), getSequenceGroup(), localTime(), and setSequenceGroup().

The documentation for this class was generated from the following file:

- BlinkSequence